{******************************************************************************}
{                       CnPack For Delphi/C++Builder                           }
{                     йԼĿԴ                         }
{                   (C)Copyright 2001-2015 CnPack                        }
{                   ------------------------------------                       }
{                                                                              }
{            ǿԴ CnPack ķЭ        }
{        ĺ·һ                                                }
{                                                                              }
{            һĿϣãûκεû        }
{        ʺضĿĶĵϸ CnPack Э顣        }
{                                                                              }
{            ӦѾͿһյһ CnPack Эĸ        }
{        ûУɷǵվ                                            }
{                                                                              }
{            վַhttp://www.cnpack.org                                   }
{            ʼmaster@cnpack.org                                       }
{                                                                              }
{******************************************************************************}

unit CnCodeGenerators;
{* |<PRE>
================================================================================
* ƣCnPack ʽר
* Ԫƣʽ CnCodeGenerators
* ԪߣCnPack
*     עõԪʵ˴ʽĲ
* ƽ̨Win2003 + Delphi 5.0
* ݲԣnot test yet
*   not test hell
* Ԫʶ$Id$
* ޸ļ¼2007-10-13 V1.0
*               뻻еĲôơ
*           2003-12-16 V0.1
*               򵥵ĴдԼ
================================================================================
|</PRE>}

interface

{$I CnPack.inc}

uses
  Classes, SysUtils, CnCodeFormatRules;

type
  TCnCodeGenerator = class
  private
    FCode: TStrings;
    FLock: Word;
    FColumnPos: Integer;
    FCodeWrapMode: TCodeWrapMode;
    FPrevStr: string;
    FPrevRow: Integer;
    FPrevColumn: Integer;
    FLastNoAutoWrapLine: Integer;
    FAutoWrapLines: TList; // ¼ԶекţѰһηԶе
    FOnAfterWrite: TNotifyEvent;
    FAutoWrapButNoIndent: Boolean;
    function GetCurIndentSpace: Integer;
    function GetLockedCount: Word;
    function GetPrevColumn: Integer;
    function GetPrevRow: Integer;
    function GetCurrColumn: Integer;
    function GetCurrRow: Integer;
    function GetLastIndentSpace: Integer;
    // ԶʱҳһԶе
    procedure CalcLastNoAutoIndentLine;
  protected
    procedure DoAfterWrite; virtual;
  public
    constructor Create;
    destructor Destroy; override;

    procedure Reset;
    procedure Write(S: string; BeforeSpaceCount:Word = 0;
      AfterSpaceCount: Word = 0);
    procedure InternalWriteln;
    procedure Writeln;
    function SourcePos: Word;
    {* һйδʹ}
    procedure SaveToStream(Stream: TStream);
    procedure SaveToFile(FileName: string);
    procedure SaveToStrings(AStrings: TStrings);

    function CopyPartOut(StartRow, StartColumn, EndRow, EndColumn: Integer): string;
    {* ָֹλøݳֱʹ Row/Column }

    procedure LockOutput;
    procedure UnLockOutput;

    procedure ClearOutputLock;
    {* ֱӽ}

    property LockedCount: Word read GetLockedCount;
    {* }
    property ColumnPos: Integer read FColumnPos;
    {* ǰĺλãڻ}
    property CurIndentSpace: Integer read GetCurIndentSpace;
    {* ǰǰĿո}
    property LastIndentSpace: Integer read GetLastIndentSpace;
    {* һԶееǰĿո}
    property CodeWrapMode: TCodeWrapMode read FCodeWrapMode write FCodeWrapMode;
    {* 뻻е}

    property PrevRow: Integer read GetPrevRow;
    {* һ Write ɹд֮ǰĹкţ0 ʼ
      ʵΪ Write дسз}
    property PrevColumn: Integer read GetPrevColumn;
    {* һ Write ɹд֮ǰĹкţ0 ʼ}
    property CurrRow: Integer read GetCurrRow;
    {* һ Write ɹд֮Ĺкţ0 ʼ
      ʵΪ Write дسз}
    property CurrColumn: Integer read GetCurrColumn;
    {* һ Write ɹд֮Ĺкţ0 ʼ}

    property AutoWrapButNoIndent: Boolean read FAutoWrapButNoIndent write FAutoWrapButNoIndent;
    {* ʱԶʱǷƣ uses  True}
    property OnAfterWrite: TNotifyEvent read FOnAfterWrite write FOnAfterWrite;
    {* дһγɹ󱻵}
  end;

implementation

{ TCnCodeGenerator }

{$IFDEF DEBUG}
uses
  CnDebug;
{$ENDIF}

const
  CRLF = #13#10;

procedure TCnCodeGenerator.CalcLastNoAutoIndentLine;
var
  I: Integer;
  MaxAuto, MaxLine: Integer;
begin
  if FAutoWrapLines.Count = 0 then // ûԶеУһ
  begin
    FLastNoAutoWrapLine := FCode.Count - 1;
    Exit;
  end;

  MaxAuto := Integer(FAutoWrapLines[FAutoWrapLines.Count - 1]);
  MaxLine := FCode.Count - 1;

  if MaxLine > MaxAuto then // һǷԶеУ
  begin
    FLastNoAutoWrapLine := MaxLine;
    Exit;
  end
  else if MaxLine = MaxAuto then
  begin
  for I := FAutoWrapLines.Count - 1 downto 0 do
  begin
    // ҵ FAutoWrapLines ͷһ
    if MaxAuto > Integer(FAutoWrapLines[I]) then
    begin
      FLastNoAutoWrapLine := MaxAuto;
      Exit;
    end;
    Dec(MaxAuto);
  end;
  end
  else
    FLastNoAutoWrapLine := -1; // Should not here
end;

procedure TCnCodeGenerator.ClearOutputLock;
begin
  FLock := 0;
end;

function TCnCodeGenerator.CopyPartOut(StartRow, StartColumn, EndRow,
  EndColumn: Integer): string;
var
  I: Integer;
begin
  Result := '';
  if EndRow > FCode.Count - 1 then
    EndRow := FCode.Count - 1;
    
  if EndRow < StartRow then Exit;
  if (EndRow = StartRow) and (EndColumn < StartColumn) then Exit;

  Inc(StartColumn);
  Inc(EndColumn); // Column  0 ʼַ± 1 ʼԶҪһ

  if EndRow = StartRow then
    Result := Copy(FCode[StartRow], StartColumn, EndColumn - StartColumn)
  else
  begin
    for I := StartRow to EndRow do
    begin
      if I = StartRow then
        Result := Result + Copy(FCode[StartRow], StartColumn, MaxInt) + CRLF
      else if I = EndRow then
        Result := Result + Copy(FCode[EndRow], 1, EndColumn)
      else
        Result := Result + FCode[I] + CRLF;
    end;
  end;
end;

constructor TCnCodeGenerator.Create;
begin
  FCode := TStringList.Create;
  FLock := 0;
  FCodeWrapMode := cwmNone;
  FAutoWrapLines := TList.Create;
end;

destructor TCnCodeGenerator.Destroy;
begin
  FAutoWrapLines.Free;
  FCode.Free;
  inherited;
end;

procedure TCnCodeGenerator.DoAfterWrite;
begin
  if Assigned(FOnAfterWrite) then
    FOnAfterWrite(Self);
end;

function TCnCodeGenerator.GetCurIndentSpace: Integer;
var
  I, Len: Integer;
begin
  Result := 0;
  if FCode.Count > 0 then
  begin
    Len := Length(FCode[FCode.Count - 1]);
    if Len > 0 then
    begin
      for I := 1 to Len do
        if FCode[FCode.Count - 1][I] in [' ', #09] then
          Inc(Result)
        else
          Exit;
    end;
  end;
end;

function TCnCodeGenerator.GetCurrColumn: Integer;
begin
  Result := FColumnPos;
end;

function TCnCodeGenerator.GetCurrRow: Integer;
begin
  Result := FCode.Count - 1;
end;

function TCnCodeGenerator.GetLastIndentSpace: Integer;
var
  I, Len: Integer;
begin
  Result := 0;
  CalcLastNoAutoIndentLine;
  if (FCode.Count > 0) and (FLastNoAutoWrapLine >= 0) and
    (FLastNoAutoWrapLine < FCode.Count) then
  begin
    Len := Length(FCode[FLastNoAutoWrapLine]);
    if Len > 0 then
    begin
      for I := 1 to Len do
        if FCode[FLastNoAutoWrapLine][I] in [' ', #09] then
          Inc(Result)
        else
          Exit;
    end;
  end;
end;

function TCnCodeGenerator.GetLockedCount: Word;
begin
  Result := FLock;
end;

function TCnCodeGenerator.GetPrevColumn: Integer;
begin
  Result := FPrevColumn;
end;

function TCnCodeGenerator.GetPrevRow: Integer;
begin
  Result := FPrevRow;
end;

procedure TCnCodeGenerator.InternalWriteln;
begin
  if FLock <> 0 then Exit;

  FCode[FCode.Count - 1] := TrimRight(FCode[FCode.Count - 1]);
  FCode.Add('');

  FColumnPos := 0;
end;

procedure TCnCodeGenerator.LockOutput;
begin
  Inc(FLock);
end;

procedure TCnCodeGenerator.Reset;
begin
  FCode.Clear;
  FAutoWrapLines.Clear;
end;

procedure TCnCodeGenerator.SaveToFile(FileName: String);
begin
  FCode.SaveToFile(FileName);
end;

procedure TCnCodeGenerator.SaveToStream(Stream: TStream);
begin
  FCode.SaveToStream(Stream {$IFDEF UNICODE}, TEncoding.Unicode {$ENDIF});
end;

procedure TCnCodeGenerator.SaveToStrings(AStrings: TStrings);
begin
  AStrings.Assign(FCode);
end;

function TCnCodeGenerator.SourcePos: Word;
begin
  Result := Length(FCode[FCode.Count - 1]);
end;

procedure TCnCodeGenerator.UnLockOutput;
begin
  Dec(FLock);
end;

procedure TCnCodeGenerator.Write(S: string; BeforeSpaceCount,
  AfterSpaceCount: Word);
var
  Str: string;
  Len: Integer;
begin
  if FLock <> 0 then Exit;
  
  if FCode.Count = 0 then
    FCode.Add('');

  Str := Format('%s%s%s', [StringOfChar(' ', BeforeSpaceCount), S,
    StringOfChar(' ', AfterSpaceCount)]);
  Len := Length(Str);

  FPrevRow := FCode.Count - 1;
  if FCodeWrapMode = cwmNone then
  begin
    // Զʱ账
  end
  else if FCodeWrapMode = cwmSimple then // 򵥻УжǷ񳬳
  begin
    if (FPrevStr <> '.') and // Dot in unitname should not new line.
     (((FColumnPos <= CnPascalCodeForRule.WrapWidth) and
      (FColumnPos + Len > CnPascalCodeForRule.WrapWidth)) or
      (FColumnPos > CnPascalCodeForRule.WrapWidth)) then
    begin
      if FAutoWrapButNoIndent then
      begin
        Str := StringOfChar(' ', CurIndentSpace) + TrimLeft(Str);
        // ԭеҪֱһ񣬱 uses ֲҪ
      end
      else
      begin
        Str := StringOfChar(' ', LastIndentSpace + CnPascalCodeForRule.TabSpaceCount)
          + TrimLeft(Str); // ԶкԭеĿոͲҪ
        // ҳһηԶǼ򵥵һֵ
      end;
      InternalWriteln;
      FAutoWrapLines.Add(Pointer(FCode.Count - 1)); // ԶекҪ¼
    end;
  end;

  FCode[FCode.Count - 1] :=
    Format('%s%s', [FCode[FCode.Count - 1], Str]);

  FPrevColumn := FColumnPos;
  FColumnPos := Length(FCode[FCode.Count - 1]);
  FPrevStr := S;

  DoAfterWrite;
{$IFDEF DEBUG}
  CnDebugger.LogFmt('String Wrote from %d %d to %d %d: %s', [FPrevRow, FPrevColumn,
    GetCurrRow, GetCurrColumn, Str]);
  CnDebugger.LogMsg(CopyPartOut(FPrevRow, FPrevColumn, GetCurrRow, GetCurrColumn));
{$ENDIF}
end;

procedure TCnCodeGenerator.Writeln;
begin
  if FLock <> 0 then Exit;

  // Write(S, BeforeSpaceCount, AfterSpaceCount);
  // delete trailing blanks
  FCode[FCode.Count - 1] := TrimRight(FCode[FCode.Count - 1]);
  FPrevRow := FCode.Count - 1;

  FCode.Add('');

  FPrevColumn := FColumnPos;
  FColumnPos := 0;
  
  DoAfterWrite;
{$IFDEF DEBUG}
  CnDebugger.LogFmt('NewLine Wrote from %d %d to %d %d', [FPrevRow, FPrevColumn,
    GetCurrRow, GetCurrColumn]);
{$ENDIF}
end;

end.
